#!/bin/bash

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

# -----------------------------------------------------------------------------------
# --- WIZARD_UIFILE / install_uifile
# -----------------------------------------------------------------------------------

# -----------------------------------------------------------------------------------
# --- Set language Strings ...
# -----------------------------------------------------------------------------------
init_lang() {
/bin/cat << EOF
inTitle1              = "Ruhezustand :"
# -----------------------------------------------------------------------------------
inTitleDesc           = "<u><b>Wichtig :</b></u> "
inTitleDesc          += "AvrLogger verhindert den <b>Ruhezustand</b> der DiskStation, solange wie die "
inTitleDesc          += "<b>Zeitplanung (Scheduling)</b> nicht aktiviert ist.<br>"
inTitleDesc          += "<br>"
inTitleDesc          += "AvrLogger bietet die Möglichkeit, die Lüfterdrehzahl über die <b>scemd.xml</b> zu ändern. "
inTitleDesc          += "Diese Funktion ist <b>experimentell</b> und die Nutzung der Funktion geschieht <b>ausdrücklich</b> auf eigene Verantwortung!<br>"
inTitleDesc          += "<br>"
inTitleDesc          += "<u><b>Empfehlung :</b></u> "
inTitleDesc          += "AvrLogger sollte über das Paket-Zentrum beendet werden, <b>bevor</b> Änderungen an den Netzwerkeinstellungen "
inTitleDesc          += "<b>oder</b> im Speicher-Manager vorgenommen werden, damit diese ohne Probleme erkannt werden.<br>"
# -----------------------------------------------------------------------------------
inBoxCheckDesc        = "Ok, habe ich zur Kenntnis genommen."
inBoxCheckValidator   = "Bitte den Haken : <b>Ok, habe ich zur Kenntnis genommen.</b> setzen um fortzufahren!"
# -----------------------------------------------------------------------------------
inTitle3              = "RamDisk (Shared Memory) :"
inTitleDesc3          = "AvrLogger kann eine <b>RamDisk (Shared Memory)</b> verwenden. Dadurch können Festplattenzugriffe minimiert "
inTitleDesc3         += "und Dateioperation beschleunigt werden.<br>"

inTitleDesc3_1        = "Das birgt jedoch die Gefahr, das im Falle eines unvorhergesehenen Neustart der DiskStation,<br>"
inTitleDesc3_1       += "z.B. bei einem Stromausfall, Daten und Einstellungen verloren gehen. AvrLogger wird in diesem "
inTitleDesc3_1       += "Fall versuchen, die Daten und Einstellungen seit dem letztem Start wieder herzustellen."

inBoxCheckDesc3       = "Ja, eine RamDisk (Shared Memory) verwenden."
inBoxCheckDesc3_1     = "Ok, habe ich zur Kenntnis genommen."
inBoxCheckValidator3  = "Bitte den Haken : <b>Ok, habe ich zur Kenntnis genommen.</b> setzen um fortzufahren!"
EOF
}

# -----------------------------------------------------------------------------------
# --- json WIZARD_UIFILE
# -----------------------------------------------------------------------------------
init_wizard() {
/bin/cat << EOF
[{
   "step_title": "${inTitle1}",
   "items": [{
      "type": "multiselect",
      "desc": "${inTitleDesc}",
      "subitems": [{
         "defaultValue": false,
         "desc":         "${inBoxCheckDesc}",
         "key":          "wizCheckNote",
         "validator":    {"fn": "{var v=arguments[0]; if (!v) return '${inBoxCheckValidator}'; return true;}"}
                  }]
         }]
},{
   "step_title": "${inTitle3}",
   "items": [{
      "type": "multiselect",
      "desc": "${inTitleDesc3}",
      "subitems": [{
         "defaultValue": true,
         "desc":         "${inBoxCheckDesc3}",
         "key":          "wizCheckShm"
         }]
   },{
      "type": "multiselect",
      "desc": "${inTitleDesc3_1}",
      "subitems": [{
         "defaultValue": false,
         "desc":         "${inBoxCheckDesc3_1}",
         "key":          "wizCheckShmNote",
         "validator":    {"fn": "{var v=arguments[0]; if (!v) return '${inBoxCheckValidator3}'; return true;}"}
                 }]
         }]

}]
EOF
}

# -----------------------------------------------------------------------------------
# --- Prepare "json WIZARD_UIFILE" ...
# -----------------------------------------------------------------------------------
var=""
while IFS= read -r line; do
   if [[ -n "${line%%\#*}" ]]; then
      value="${line#*\"}"
      if [ -z "${line/* \+\= *}" ]
         then var+="${line%% *}+=\"${value%\"*}\"\n"
         else var+="${line%% *}=\"${value%\"*}\"\n"
      fi
   fi
done <<<"$(init_lang)"
source <(echo -e $var)
# -----------------------------------------------------------------------------------

# -----------------------------------------------------------------------------------
echo -e "$(init_wizard)" > $SYNOPKG_TEMP_LOGFILE
# -----------------------------------------------------------------------------------

exit 0

# ---- END ----
