# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

import sys
import json

import asset
import basics   as io
from   Html     import *
import lib

import isAdmin
import Status

FuncName    = 'debug'

# ---------------------------------------------------------------------------------
# --- Pre-Initialization
# ---------------------------------------------------------------------------------
def pre( site, more ):
   pass

# ---------------------------------------------------------------------------------
# --- Post-Initialization
# ---------------------------------------------------------------------------------
def post( site, more ):
   pass

# ------------------------------------------------------------------------------
# --- "debug" - Page
# ------------------------------------------------------------------------------
def Func( site=False, more=False ) :

   # ---------------------------------------------------------------------------
   # --- Header "fieldset" ausgeben ...
   fieldset_header()
   # ---------------------------------------------------------------------------

   # ---------------------------------------------------------------------------
   # --- Print Debug-Content (Info) :
   # ---------------------------------------------------------------------------
   Content()
   # ---------------------------------------------------------------------------

   # ---------------------------------------------------------------------------
   # --- "Zurück" Button ausgeben ...
   Button1_l ( 'Back', 'manage' )

   # --- Footer "fieldset" ausgeben ...
   fieldset_footer()


# ------------------------------------------------------------------------------
# --- Print Debug-Content (Info) :
# ------------------------------------------------------------------------------
def Content ( opt=False ) :

   if not bool( asset.SynoInfo ) : asset.SynoInfo = lib.FileConfig( asset.sysSynoConfig )
   CSRF = asset.SynoInfo[ 'enable_syno_token' ]

   # ---------------------------------------------------------------------------
   # --- Prevent CSRF Attack :
   # ---------------------------------------------------------------------------
   print ( '<h3 class="OverFlowDebug">Prevent CSRF Attack :</h3>' )
   print (f'Request result: [{CSRF}]' )
   print ( '<hr>' )

   # ---------------------------------------------------------------------------
   # --- SynoToken :
   # ---------------------------------------------------------------------------
   print ( '<h3 class="OverFlowDebug">SynoToken :</h3>' )
   try :
      SynoToken = isAdmin.getSynoToken()
      print ( f'Request result: [{SynoToken}]' )
   except :
      SynoToken = False
      pass

   if not SynoToken :
      print ( "------------------- Request failed - Raw Content -------------------" )
      RawToken = lib.getCMD( '/usr/syno/synoman/webman/login.cgi' )
      print ( RawToken )

   print ( '<hr>' )

   # ---------------------------------------------------------------------------
   # --- Authentification :
   # ---------------------------------------------------------------------------
   print ( '<h3 class="OverFlowDebug">Authentification :</h3>' )
   SynoUser = isAdmin.getAuthentification( SynoToken )

   if not SynoUser :
      print ( "Request failed - Not logged in !" )
   else :
      print ( f'Request result: [{SynoUser}]' )

   print ( '<hr>' )

   # ---------------------------------------------------------------------------
   # --- User is-Admin :
   # ---------------------------------------------------------------------------
   if SynoUser :
      print ( '<h3 class="OverFlowDebug">Is Admin :</h3>' )

      iAdmin = isAdmin.CheckUserIsAdmin( SynoUser )

      if iAdmin :
         print ( "Request result: [Yes]" )
      else :
         print ( "Request result: [No]" )

   print ( '<hr>' )

   # ---------------------------------------------------------------------------
   # --- App Privileg :
   # ---------------------------------------------------------------------------
   if SynoUser :
      print ( '<h3 class="OverFlowDebug">APP Privileg :</h3>' )

      if not isAdmin.CheckAppPrivileg( SynoUser, f'SYNO.SDS.{asset.cgiNameConfig}.Application' ) :
         print ( f'Request result: [No] for [{asset.cgiNameConfig}]' )
      else :
         print ( f'Request result: [Yes] for [{asset.cgiNameConfig}]' )

      if not isAdmin.CheckAppPrivileg( SynoUser, f'SYNO.SDS.{asset.cgiNameChart}.Application' ) :
         print ( f'Request result: [No] for [{asset.cgiNameChart}]' )
      else :
         print ( f'Request result: [Yes] for [{asset.cgiNameChart}]' )

   # ---------------------------------------------------------------------------
   # --- Status report :
   # ---------------------------------------------------------------------------
   if not opt and SynoUser :
      print ( '<hr>' )
      print ( '<h3 class="OverFlowDebug">Status Report :</h3>' )

      Status.Body = ""
      Status.System()
      Status.Disk  ()
      Status.Smart ()
      Status.Body += "+--------------------------------------------------------------------------------------+\n"
      print ( Status.Body )
   
   # ---------------------------------------------------------------------------
   # --- Error-Log :
   # ---------------------------------------------------------------------------
   if opt and SynoUser and iAdmin :
      print ( '<hr>' )
      print ( '<h3 class="OverFlowDebug">Environmental variables :</h3>' )

      iLen = 0
      sList = dict()

      for key in os.environ :
         if len( key ) > iLen :
            iLen = len( key ) + 1

      for key in sorted( os.environ ) :
         print ( '{0:{width}} = {1}'.format( key, os.environ[key], width=iLen ) )

      print ( '<hr>' )
      print ( '<h3 class="OverFlowDebug">Error-Log :</h3>' )
      print ( io.ioRead( asset.ERROR ) )

   # ---------------------------------------------------------------------------
#  print ( "<h3><br></h3>" )

# --------------------------------------- END ---------------------------------------
# -----------------------------------------------------------------------------------
#  sys.exit()
# -----------------------------------------------------------------------------------
# -----------------------------------------------------------------------------------
