# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------------#
# openJDK - Java management tool.                                                    #
# Copyright (C) 2021 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "openJDK.spk"                                                 #
#                                                                                    #
# openJDK is free software: you can redistribute it and/or modify                    #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

import sys

import asset
import basics as io
from   Html   import *
import lib
from   lib    import switch, case

FuncName = 'folder'

# ---------------------------------------------------------------------------------
# --- Pre-Initialization
# ---------------------------------------------------------------------------------
def pre( site, more ):

   while switch( f'{site}+{more}' ) :
      # ---------------------------------------------------------------------------
      if case( 'folder+ok' ):

         asset.cgiInput['page'] = asset.cgiInput['CalledPageOk']
         asset.cgiInput[asset.cgiInput['FolderRetName']] = asset.cgiInput['FolderCurDir']

         sDict = dict()
         for key in asset.cgiInput :
            sDict[key] = asset.cgiInput[key]

         CallPage ( sDict )
         sys.exit()
         break

      # ---------------------------------------------------------------------------
      if case( 'folder+cancel' ):

         asset.cgiInput['page'] = asset.cgiInput['CalledPageCancel']

         sDict = dict()
         for key in asset.cgiInput :
            sDict[key] = asset.cgiInput[key]

         CallPage ( sDict )
         sys.exit()
         break

      # ---------------------------------------------------------------------------
      if case( 'folder+fileOk' ):
         sName, sExt = os.path.splitext( os.path.basename( asset.cgiInput['FolderCurFile'] ) )
         cExt = asset.cgiInput['FolderCurExt'].strip('*').strip('.')

         if not sExt or sExt != cExt :
            sFile = '{0}/{1}.{2}'.format( asset.cgiInput['FolderCurDir'], sName, cExt )
         else :
            sFile = '{0}/{1}.{2}'.format( asset.cgiInput['FolderCurDir'], sName, sExt )

         asset.cgiInput['page'] = asset.cgiInput['CalledPageOk']
         asset.cgiInput[asset.cgiInput['FolderRetName']] = sFile

         sDict = dict()
         for key in asset.cgiInput :
            sDict[key] = asset.cgiInput[key]

         CallPage ( sDict )
         sys.exit()
         break

      # ---------------------------------------------------------------------------
      if case( 'folder+fileCancel' ):

         asset.cgiInput['page'] = asset.cgiInput['CalledPageCancel']

         sDict = dict()
         for key in asset.cgiInput :
            sDict[key] = asset.cgiInput[key]

         CallPage ( sDict )
         sys.exit()
         break

      # ---------------------------------------------------------------------------
      break

# ---------------------------------------------------------------------------------
# --- Post-Initialization
# ---------------------------------------------------------------------------------
def post( site, more ):

   try :
      more, sDir = more.split( '#', 1 )
      sDir = sDir.strip( '/' )
   except :
      sDir = ''

   while switch( f'{site}+{more}' ) :
      # ---------------------------------------------------------------------------
      if case( 'folder+back' ):

         if '/' in sDir : asset.cgiInput['FolderCurDir'] = '/'.join( sDir.split( '/' )[0:-1] )
         else           : asset.cgiInput['FolderCurDir'] = sDir

         if 'FolderHome' in asset.cgiInput and asset.cgiInput['FolderHome'] :
            if 'var/packages' in sDir or '{0}/{1}'.format( asset.SpkName, asset.cgiInput['FolderHome'].strip( '/' ).split( '/' )[-1] ) in sDir :
               asset.cgiInput['FolderCurDir'] = asset.cgiInput['FolderHome']

         break

      # ---------------------------------------------------------------------------
      if case( 'folder+newFolder' ):
         asset.cgiInput['FolderCurDir'] = sDir

         break

      # ---------------------------------------------------------------------------
      if case( 'folder+newFile' ):
         asset.cgiInput['FolderCurDir']  = os.path.dirname ( sDir )
         asset.cgiInput['FolderCurFile'] = os.path.basename( sDir )

      break      

      # ---------------------------------------------------------------------------
      break      

   # ------------------------------------------------------------------------------
   # --- Prepare Values ...
   for key in asset.cgiInput :
      asset.Out[key] = asset.cgiInput[key]

# ---------------------------------------------------------------------------------
# --- "folder" - Select-Folder Dialog-Page
# ---------------------------------------------------------------------------------
def Func( site=False, more=False ) :

   import __main__ as pMain
   iWidth   = iMainOutWidth
   iHeight  = iMainHeight

   Out = asset.Out
   s   = asset.msg

   if 'FolderHome' in Out and Out['FolderHome'] :
      Home = { asset.SpkName : Out['FolderHome'] }
   else :
      Home = False

   micro = pMain.more.split( '#', 1 )[-1]

   if micro.startswith( 'volume' ) :
      sShare = micro.split( '/', 1 )[-1].split( '/' )[0]
   else :
      sShare = micro.split( 'var/packages/', 1 )[-1].split( '/' )[0]
      
   # ------------------------------------------------------------------------------
   # --- Get Basic-Informations from given Path ...
   f  = io.ShareTree( isRoot=Home )
   fList = f.GetContent( Out['FolderCurDir'], sMask=Out['FolderCurExt'] )

   asset.Out['FolderCurDir'] = fList['fullPath'].strip( '/' )

   if 'volume' in Out['FolderCurDir'].strip( '/').split( '/', 1 )[0] :
      if '/' in Out['FolderCurDir'] : asset.Out['FolderCurDir'] = Out['FolderCurDir'].split( '/', 1 )[1]
      else                          : asset.Out['FolderCurDir'] = '/'
   else :
      if 'var/packages' in Out['FolderCurDir'] :
         asset.Out['FolderCurDir'] = '{0}/{1}'.format( asset.SpkName, Out['FolderCurDir'].strip( '/' ).split( '/' )[-1] )

   asset.Out['CurFolderOnly']   = Out['FolderCurDir'].strip( '/' ).split( '/' )[-1]
      
   # ------------------------------------------------------------------------------
   if Out['FolderMode'] == 'GetFile' : FileMode = True
   else :                              FileMode = False

   # ------------------------------------------------------------------------------
   # --- Backtrace Variablen ...
   lib.unset( asset.cgiInput, 'FolderCurDir' )
   lib.unset( asset.cgiInput, 'FolderCurFile' )

   for key in asset.cgiInput :
      Hide ( key )

   # ------------------------------------------------------------------------------
   # --- Header "fieldset" ausgeben ...
   ContentOpen()
   # --------------------------------------------------------------------------------
   ContentRow ()
   ContentTab ( 640, 100 )

   # ------------------------------------------------------------------------------
   Section ( Out['FolderBaseTitel'] )

   Load, Save = f.PathExist ( fList['fullPath'] )

   RowOpen  ()
   RoBox    ( 'FolderCurDir', 'CurPathOnly',    54, 560, opt=not Load )
   RowClose ()

   RowOpen  ()
   RoBox    ( 'CurFolderOnly', 'CurFolderOnly', 54, 560, opt=not Load )
   RowClose ()

   RowOpen  ()
   if FileMode :
      Input ( 'FolderCurFile', 'FolderCurFile', 54, 323 )
      RoBox ( 'FolderCurExt',  '',               0,  60 )
      if Out['CurFolderOnly'] != "" and Out['FolderCurFile'] != "" and Load :
         Button( 'ButtonFileOk',     '- Ok -',     f'{asset.PageName}-{FuncName}+fileOk'     )
      Button   ( 'ButtonFileCancel', '- Cancel -', f'{asset.PageName}-{FuncName}+fileCancel' )
   else :
      Label ( '&nbsp;', 454 )
      if Out['CurFolderOnly'] != "" and Load :
         Button( 'ButtonFolderOk',     '- Ok -',     f'{asset.PageName}-{FuncName}+ok'     )
      Button   ( 'ButtonFolderCancel', '- Cancel -', f'{asset.PageName}-{FuncName}+cancel' )
   RowClose ()

   # ------------------------------------------------------------------------------
   ContentTabEnd()
   ContentRowEnd()

   # ------------------------------------------------------------------------------
   # --- open 1/4 fieldset : List of Shares
   # ------------------------------------------------------------------------------
   ContentRow ()
   ContentTab ( 205, 463 )
   # ------------------------------------------------------------------------------

   Section ( 'FolderShares' )
   print ( '               <div id="ShareScroll" class="ScrollBar OverFlow-Folder-Y" style="margin-left: 2px;">' )

   for sID in sorted( fList['Shares'] ) :

      if Home and 'var/packages' in fList['Shares'][sID] :
         Icon = '{0}_48.png'.format( asset.SpkName )
      else :
         Icon = 'SharedFolder.png'

      if sShare == sID : opt=True
      else             : opt=False

      refBtn   ( sID, 143, Icon, f'{asset.PageName}-{FuncName}+newFolder#' + fList['Shares'][sID].split( '/', 1 )[1], 0, opt=opt )

   print ( '                  <script>rtfScrollDivTo( "ShareScroll", "subMenuIconActive" )</script>' )
   print ( '               </div>' )
   # ------------------------------------------------------------------------------
   # --- Close 1/4 fieldset : List of Shares
   ContentTabEnd()
   # ------------------------------------------------------------------------------

   # ------------------------------------------------------------------------------
   # --- open 3/4 fieldset : List of Folders / Files
   # ------------------------------------------------------------------------------
   ContentTab ( 433, 463 )
   # ------------------------------------------------------------------------------
   Section ( 'FolderContent' )
   print ( '               <div id="ShareScroll" class="ScrollBar OverFlow-Folder-Y" style="margin-left: 2px;">' )

   if '/' in Out['FolderCurDir'] and not fList['fullPath'].startswith( '/var/packages/' ) :
      refBtn   ( 'ButtonGoBack',       400, 'GoBack.png', f'{asset.PageName}-{FuncName}+back#{Out[ "FolderCurDir"]}',   0 )

   for sID in fList['Folders'] :

      sID = sID.strip( '/' )

      refBtn   ( sID.split( '/' )[-1], 400, 'Folder.png', f'{asset.PageName}-{FuncName}+newFolder#' + sID.split( '/', 1 )[1], 0 )

   # ------------------------------------------------------------------------------
   if FileMode :
      for sID in fList['Files'] :

         sID = sID.strip( '/' )

         refBtn   ( sID.split( '/' )[-1], 400, Out['FileIcon'], f'{asset.PageName}-{FuncName}+newFile#' + sID, 0 )

   print ( '                  <script>rtfScrollDivTo( "ShareScroll", "subMenuIconActive" )</script>' )
   print ( '               </div>' )
   # ------------------------------------------------------------------------------
   # --- Close 3/4 fieldset : List of Folders / Files
   ContentTabEnd()
   ContentRowEnd()

   # ------------------------------------------------------------------------------
   Hide ( 'FolderCurDir' )
   # ------------------------------------------------------------------------------
   ContentClose()

# --------------------------------------- END ---------------------------------------
# -----------------------------------------------------------------------------------
#  sys.exit()
# -----------------------------------------------------------------------------------
# -----------------------------------------------------------------------------------
