# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

import asset
import basics  as io

from   Html    import *

import lib
from   lib    import switch, case

# -----------------------------------------------------------------------------------
# --- Global options ...
# -----------------------------------------------------------------------------------
import __main__  as pMain

FuncName    = 'log'

# -----------------------------------------------------------------------------------
# --- Pre-Initialization
# -----------------------------------------------------------------------------------
def pre( site, more ):

   while switch( f'{site}+{more}' ) :
      # ---------------------------------------------------------------------------
      if case( 'log+clear' ) :
         # --- Clear the Log-File "ERROR" ...
         io.ioRm  ( asset.ERROR )
         io.touch ( asset.ERROR )
         break

      # ---------------------------------------------------------------------------
      if case( 'log+backup' ) :
         # --- Backup settings ...
         import Manage
         Manage.BackupSettings( pMain.Avr[ 'SvgArchivePath' ] )
         break

      # ---------------------------------------------------------------------------
      if case( 'log+restore' ) :
         # --- Restore settings ...
         import Manage
         sPath = Manage.RestoreSettings( pMain.Avr[ 'SvgArchivePath' ] )
         sName = 'log.conf'

         if sPath :
            import Config
            sFile = '/'.join(( sPath, sName ))

            if os.path.exists( sFile ) :
               pst = Config.Configs( sSource=sFile )
               asset.cgiInput = { **pst.sSource }
               import main
               main.save()
               lib.Error ( "GUI: Restored successfully: \"" + sName + "\"" )
         break

      # ---------------------------------------------------------------------------
      break

# -----------------------------------------------------------------------------------
# --- Post-Initialization
# -----------------------------------------------------------------------------------
def post( site, more ):
   pass

# -----------------------------------------------------------------------------------
# --- "Log" - Page
# -----------------------------------------------------------------------------------
def Func( site=False, more=False ):

   # --- Header "fieldset" ausgeben ...
   print ( '         <fieldset class="WhiteMonoShell" >' )
   print ( '            <div class="WhiteMonoShell"> <!-- divOpenBlk -->' )
   print ( '               <pre class="WhiteMonoShell">' ) 
   print ( '                  <div id="ShareScroll" class="ScrollBar OverFlowHddList"> <!-- Start DivScroll -->' )

   # --- Print content of File ...
   print ( io.ioRead( asset.ERROR ) )

   print ( '                  </div> <!-- End DivScroll -->' )
   print ( '               </pre>' )
   print ( '            </div> <!-- divCloseBlk -->' )

   # --------------------------------------------------------------------------------
   # --- "Clear" Button ausgeben ...
   if asset.sysCookies['SynoAdmin'] :
      Button1_l ( 'Clear',  f'{asset.PageName}-{FuncName}+clear', sClass='BlueButton' )

   # --- Footer "fieldset" ausgeben ...
   print ( '         </fieldset>' )
   print ( '      </form>' )
   print ( '   </body>' )
   print ( '</html>' )

# --------------------------------------- END ---------------------------------------
# -----------------------------------------------------------------------------------
#  sys.exit()
# -----------------------------------------------------------------------------------
# -----------------------------------------------------------------------------------
