# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

import asset
from   Html  import *

from   lib   import switch, case

# -----------------------------------------------------------------------------------
# --- Global options ...
# -----------------------------------------------------------------------------------
import __main__  as pMain

FuncName = 'axis'

FuncDesc = { 'IconName'     : 'Axis.png',
             'SubName'      : asset.msg['modChartAxisName'],
             'SubText'      : asset.msg['modChartAxisText'],
             'iWidth'       : SubMenuWidth,
             'iOnChange'    : f'{asset.PageName}-{FuncName}+OnChange',
           }

# -----------------------------------------------------------------------------------
# --- Pre-Initialization
# -----------------------------------------------------------------------------------
def pre( site, more ) :
   pass

# -----------------------------------------------------------------------------------
# --- Post-Initialization
# -----------------------------------------------------------------------------------
def post( site, more ) :

   while switch( f'{site}+{more}' ) :
      # -----------------------------------------------------------------------------
      if case( 'axis+save' ) :
         UsvInputNominal   = int( asset.cgiInput[ 'UsvInputNominal'   ] )
         UsvInputTolerance = int( asset.cgiInput[ 'UsvInputTolerance' ] )

         UsvInputMin = int( ( UsvInputNominal / 100 ) * ( 100 - UsvInputTolerance ) )
         UsvInputMax = int( ( UsvInputNominal / 100 ) * ( 100 + UsvInputTolerance ) )

         asset.cgiInput[ 'Sec3Min'      ] = f'{UsvInputMin}' # Start-Wert
         asset.cgiInput[ 'Sec3ScaleMin' ] = f'{UsvInputMin}' # Skalierung Min.
         asset.cgiInput[ 'Sec3ScaleMax' ] = f'{UsvInputMax}' # Skalierung Max.

         # --------------------------------------------------------------------------
         import main
         main.save()

         break

      # -----------------------------------------------------------------------------
      if case( 'axis+OnChange' ):
         UsvInputNominal   = int( asset.cgiInput[ 'UsvInputNominal'   ] )
         UsvInputTolerance = int( asset.cgiInput[ 'UsvInputTolerance' ] )

         UsvInputMin = int( ( UsvInputNominal / 100 ) * ( 100 - UsvInputTolerance ) )
         UsvInputMax = int( ( UsvInputNominal / 100 ) * ( 100 + UsvInputTolerance ) )

         asset.cgiInput[ 'Sec3Min'      ] = f'{UsvInputMin}' # Start-Wert
         asset.cgiInput[ 'Sec3ScaleMin' ] = f'{UsvInputMin}' # Skalierung Min.
         asset.cgiInput[ 'Sec3ScaleMax' ] = f'{UsvInputMax}' # Skalierung Max.

         break

   # --------------------------------------------------------------------------------
   # --- Prepare Values ...
   for sKey in asset.cgiInput :
      asset.Out[ sKey] = asset.cgiInput[ sKey ]

# -----------------------------------------------------------------------------------
# --- Function : "axis"
# -----------------------------------------------------------------------------------
def Func ( sSite, sMore ) :

   iWidth   = iMainOutWidth
   iHeight  = iMainHeight

   s           = asset.msg
   Out         = asset.Out
   iAccCnt     = 0

   if Out['ExpertModeOn'] == 'Yes': ExpertMode = True
   else                           : ExpertMode = False

   # --------------------------------------------------------------------------------
   asset.Out['AcdActive'] = 1

   for key in asset.cgiInput :
      if 'AcdReturn' in key and asset.cgiInput[key] == 'Yes' :
         asset.Out['AcdActive'] = int( key.split( '_', 1 )[-1] )
         break

   # --------------------------------------------------------------------------------
   ContentOpen()
   # --------------------------------------------------------------------------------
   ContentTab ( iWidth, iHeight - iMainSaveHeight )
   # --------------------------------------------------------------------------------
   iAccCnt += 1
   SectionOpen( 'AxisUnits', iIndex=iAccCnt )
   # --------------------------------------------------------------------------------
   ContentRow ()
   # --------------------------------------------------------------------------------
   ContentTab ( 260, 100 )
   # --------------------------------------------------------------------------------

   RowOpen    ()
   CheckBox   ( 'LegAxisHeadlineOn', 'LegAxisHeadlineOn',   80 )
   SelectGUI  ( 'LegAxisHeadPos',    'Pos :',     s['LegAxisHeadPosGUI'], Out['LegAxisHeadPosRAW'], 20, 87 )
   RowClose   ()

   RowOpen    ()
   Input      ( 'LegAxisHeadOffset', 'Offset :',            80, Box_Input )
   RowClose   ()

   # --------------------------------------------------------------------------------
   ContentTabEnd()
   ContentTab( 260, 100 )
   # --------------------------------------------------------------------------------

   RowOpen  ()
   CheckBox ( 'LegAxisUnitOn',      'LegAxisUnitOn',        80 )
   RowClose ()

   RowOpen  ()
   Input    ( 'LegAxisOffset',      'Offset :',             80, Box_Input )
   RowClose ()

   # --------------------------------------------------------------------------------
   ContentTabEnd()
   ContentTab( 260, 100 )
   # --------------------------------------------------------------------------------

   RowOpen  ()
   Input    ( 'PlotLabelWidth',    'PlotLabelWidth',        80, Box_Input )
   RowClose ()

   RowOpen  ()
   Input    ( 'PlotLabelHeight',   'LegTabY',               80, Box_Input )
   RowClose ()

   RowOpen  ()
   Input    ( 'LegAxisLine',       'Line:',                 80, Box_Input )
   RowClose ()

   ContentTabEnd()
   ContentRowEnd()
   SectionClose()

   # --------------------------------------------------------------------------------
   # --- Ookla Ping (ms) : Pri3LabelOn
   # --------------------------------------------------------------------------------
   iAccCnt += 1
   SectionOpen( 'Speedtest_IO', iIndex=iAccCnt )
   # --------------------------------------------------------------------------------
   ContentRow ()
   # --------------------------------------------------------------------------------
   ContentTab ( 390, 180 )
   # --------------------------------------------------------------------------------

   RowOpen  ()
   CheckBox ( 'Pri3LabelOn',    'LabelOnOff',                                          90 )
   RowClose ()

   RowOpen  ()
   Color    ( 'Pri3LabelColor', 'LabelColor',                                          90, Box_Color )
   RowClose ()

   RowOpen  ()
   # --> 'Ping "ms" :'
   Input    ( 'Pri3LabelHeadline', 'AxisName',                                               90, Box_1b    )
   RowClose ()

   RowOpen  ()
   # --> 'Ping "ms" :'
   Input    ( 'Pri3LabelSuffix',   'AxisUnit',                                               90, Box_1b    )
   RowClose ()

   RowOpen  ()
   Select   ( 'Pri3LabelSize',  'LabelSize', '50 60 80 85 90 95 100 105 110 115 120',        90, Box_1b )
   RowClose ()

   RowOpen  ()
   Input    ( 'Pri3LabelPos',    'Offset X :',                                               90, Box_Input )
   RowClose ()

   RowOpen  ()
   Input    ( 'Pri3LabelOffset', 'Offset Y :',                                               90, Box_Input )
   RowClose ()

   # --------------------------------------------------------------------------------
   ContentTabEnd()
   ContentTab ( 390, 180 )
   # --------------------------------------------------------------------------------

   RowOpen  ()
   SelectGUI( 'Pri3ScaleType',  'ScaleType', s['AxisScaleTypeGUI'], s['AxisScaleTypeRAW'],   90, 122 )
   RowClose ()

   RowOpen  ()
   Input    ( 'Pri3Min',        'Start :',                                                  90, Box_Input )
   RowClose ()

   RowOpen  ()
   Input    ( 'Pri3ScaleMin',   'Min :',                                                    90, Box_Input )
   RowClose ()

   RowOpen  ()
   Input    ( 'Pri3ScaleMax',   'Max :',                                                    90, Box_Input )
   RowClose ()


   ContentTabEnd ()
   ContentRowEnd ()
   SectionClose  ()

   # --------------------------------------------------------------------------------
   # --- Network I/O (MiB/s) : Pri2LabelOn
   # --------------------------------------------------------------------------------
   iAccCnt += 1
   SectionOpen( 'Pri2LabelOn', iIndex=iAccCnt )
   # --------------------------------------------------------------------------------
   ContentRow ()
   # --------------------------------------------------------------------------------
   ContentTab ( 390, 180 )
   # --------------------------------------------------------------------------------

   RowOpen  ()
   CheckBox ( 'Pri2LabelOn',    'LabelOnOff',                                          90 )
   RowClose ()

   RowOpen  ()
   Color    ( 'Pri2LabelColor', 'LabelColor',                                          90, Box_Color )
   RowClose ()

   RowOpen  ()
   # --> 'LAN "I/O" :'
   Input    ( 'Pri2LabelHeadline', 'AxisName',                                               90, Box_1b    )
   RowClose ()

   RowOpen  ()
   # --> 'LAN "I/O" :'
   Input    ( 'Pri2LabelSuffix',   'AxisUnit',                                               90, Box_1b    )
   RowClose ()

   RowOpen  ()
   Select   ( 'Pri2LabelSize',  'LabelSize', '50 60 80 85 90 95 100 105 110 115 120',        90, Box_1b )
   RowClose ()

   RowOpen  ()
   Input    ( 'Pri2LabelPos',    'Offset X :',                                               90, Box_Input )
   RowClose ()

   RowOpen  ()
   Input    ( 'Pri2LabelOffset', 'Offset Y :',                                               90, Box_Input )
   RowClose ()

   # --------------------------------------------------------------------------------
   ContentTabEnd()
   ContentTab ( 390, 180 )
   # --------------------------------------------------------------------------------

   RowOpen  ()
   SelectGUI( 'Pri2ScaleType',  'ScaleType', s['AxisScaleTypeGUI'], s['AxisScaleTypeRAW'],   90, 122 )
   RowClose ()

   RowOpen  ()
   Input    ( 'Pri2Min',        'Start :',                                                  90, Box_Input )
   RowClose ()

   RowOpen  ()
   Input    ( 'Pri2ScaleMin',   'Min :',                                                    90, Box_Input )
   RowClose ()

   RowOpen  ()
   Input    ( 'Pri2ScaleMax',   'Max :',                                                    90, Box_Input )
   RowClose ()


   ContentTabEnd ()
   ContentRowEnd ()
   SectionClose  ()

   # --------------------------------------------------------------------------------
   # --- Temperature (°C) : Pri1LabelOn
   # --------------------------------------------------------------------------------
   iAccCnt += 1
   SectionOpen( 'Pri1LabelOn', iIndex=iAccCnt )
   # --------------------------------------------------------------------------------
   ContentRow ()
   # --------------------------------------------------------------------------------
   ContentTab ( 390, 180 )
   # --------------------------------------------------------------------------------

   RowOpen  ()
   CheckBox ( 'Pri1LabelOn',    'LabelOnOff',                                               90 )
   RowClose ()

   RowOpen  ()
   Color    ( 'Pri1LabelColor', 'LabelColor',                                               90, Box_Color )
   RowClose ()

   RowOpen  ()
   # --> 'Temp "°C" :'
   Input    ( 'Pri1LabelHeadline', 'AxisName',            90, Box_1b    )
   RowClose ()

   RowOpen  ()
   # --> 'Temp "°C" :'
   Input     ( 'Pri1LabelSuffix',   'AxisUnit',           90, Box_1b    )
   RowClose ()

   RowOpen  ()
   Select    ( 'Pri1LabelSize',  'LabelSize', '50 60 80 85 90 95 100 105 110 115 120',       90, Box_1b )
   RowClose ()

   RowOpen  ()
   Input    ( 'Pri1LabelPos',    'Offset X :',                                                   90, Box_Input )
   RowClose ()

   RowOpen  ()
   Input    ( 'Pri1LabelOffset', 'Offset Y :',                                                   90, Box_Input )
   RowClose ()

   # --------------------------------------------------------------------------------
   ContentTabEnd()
   ContentTab ( 390, 180 )
   # --------------------------------------------------------------------------------

   RowOpen  ()
   SelectGUI( 'Pri1ScaleType',  'ScaleType', s['AxisScaleTypeGUI'], s['AxisScaleTypeRAW'],  90, 122 )
   RowClose ()

   RowOpen  ()
   Input    ( 'Pri1Min',        'Start :',                                                  90, Box_Input )
   RowClose ()

   RowOpen  ()
   Input    ( 'Pri1ScaleMin',   'Min :',                                                    90, Box_Input )
   RowClose ()

   RowOpen  ()
   Input    ( 'Pri1ScaleMax',   'Max :',                                                    90, Box_Input )
   RowClose ()

   ContentTabEnd ()
   ContentRowEnd ()
   SectionClose  ()

   # --------------------------------------------------------------------------------
   # --- Load (percent %) : Sec1LabelOn
   # --------------------------------------------------------------------------------
   iAccCnt += 1
   SectionOpen( 'Sec1LabelOn', iIndex=iAccCnt )
   # --------------------------------------------------------------------------------
   ContentRow ()
   ContentTab ( 390, 180 )
   # --------------------------------------------------------------------------------

   RowOpen  ()
   CheckBox ( 'Sec1LabelOn',    'LabelOnOff',                                               90 )
   RowClose()

   RowOpen  ()
   Color    ( 'Sec1LabelColor', 'LabelColor',                                               90, Box_Color )
   RowClose()

   RowOpen ()
   # --> 'Load "%" :'
   Input   ( 'Sec1LabelHeadline', 'AxisName',             90, Box_1b    )
   RowClose()

   RowOpen  ()
   # --> 'Load "%" :'
   Input    ( 'Sec1LabelSuffix',   'AxisUnit',            90, Box_1b    )
   RowClose ()

   RowOpen  ()
   Select   ( 'Sec1LabelSize',  'LabelSize', '50 60 80 85 90 95 100 105 110 115 120',       90, Box_1b )
   RowClose()

   RowOpen  ()
   Input   ( 'Sec1LabelPos',    'Offset X :',                                                   90, Box_Input )
   RowClose()

   RowOpen  ()
   Input   ( 'Sec1LabelOffset', 'Offset Y :',                                                   90, Box_Input )
   RowClose()

   # --------------------------------------------------------------------------------
   ContentTabEnd()
   ContentTab ( 390, 180 )
   # --------------------------------------------------------------------------------

   RowOpen  ()
   SelectGUI( 'Sec1ScaleType',  'ScaleType', s['AxisScaleTypeGUI'], s['AxisScaleTypeRAW'],  90, 122 )
   RowClose ()

   RowOpen  ()
   Input    ( 'Sec1Min',        'Start :',                                                  90, Box_Input )
   RowClose ()

   RowOpen  ()
   Input    ( 'Sec1ScaleMin',   'Min :',                                                    90, Box_Input )
   RowClose ()

   RowOpen  ()
   Input    ( 'Sec1ScaleMax',   'Max :',                                                    90, Box_Input )
   RowClose ()

   ContentTabEnd ()
   ContentRowEnd ()
   SectionClose  ()

   # --------------------------------------------------------------------------------
   # --- Storage I/O (MiB/s) : Sec2LabelOn
   # --------------------------------------------------------------------------------
   iAccCnt += 1
   SectionOpen( 'Sec2LabelOn', iIndex=iAccCnt )
   # --------------------------------------------------------------------------------
   ContentRow ()
   ContentTab ( 390, 180 )
   # --------------------------------------------------------------------------------

   RowOpen  ()
   CheckBox ( 'Sec2LabelOn',    'LabelOnOff',                                               90 )
   RowClose ()

   RowOpen ()
   Color    ( 'Sec2LabelColor', 'LabelColor',                                               90, Box_Color )
   RowClose ()

   RowOpen ()
   # --> 'Disk "I/O" :'
   Input   ( 'Sec2LabelHeadline', 'AxisName',           90, Box_1b    )
   RowClose()

   RowOpen  ()
   # --> 'Disk "I/O" :'
   Input    ( 'Sec2LabelSuffix',   'AxisUnit',          90, Box_1b    )
   RowClose ()

   RowOpen ()
   Select   ( 'Sec2LabelSize',  'LabelSize', '50 60 80 85 90 95 100 105 110 115 120',       90, Box_1b )
   RowClose ()

   RowOpen ()
   Input   ( 'Sec2LabelPos',    'Offset X :',                                                   90, Box_Input )
   RowClose ()

   RowOpen ()
   Input   ( 'Sec2LabelOffset', 'Offset Y :',                                                   90, Box_Input )
   RowClose ()

   # --------------------------------------------------------------------------------
   ContentTabEnd()
   ContentTab ( 390, 180 )
   # --------------------------------------------------------------------------------

   RowOpen  ()
   SelectGUI( 'Sec2ScaleType',  'ScaleType', s['AxisScaleTypeGUI'], s['AxisScaleTypeRAW'],  90, 122 )
   RowClose ()

   RowOpen ()
   Input    ( 'Sec2Min',        'Start :',                                                  90, Box_Input )
   RowClose ()

   RowOpen ()
   Input    ( 'Sec2ScaleMin',   'Min :',                                                    90, Box_Input )
   RowClose ()

   RowOpen ()
   Input    ( 'Sec2ScaleMax',   'Max :',                                                    90, Box_Input )
   RowClose ()

   ContentTabEnd ()
   ContentRowEnd ()
   SectionClose  ()

   # --------------------------------------------------------------------------------
   # --- USV : Sec3LabelOn
   # --------------------------------------------------------------------------------
   iAccCnt += 1
   SectionOpen( 'UpsInputAc', iIndex=iAccCnt )
   # --------------------------------------------------------------------------------
   ContentRow ()
   ContentTab ( 390, 180 )
   # --------------------------------------------------------------------------------

   RowOpen  ()
   CheckBox ( 'Sec3LabelOn',    'LabelOnOff',                                               90 )
   RowClose ()

   RowOpen ()
   Color    ( 'Sec3LabelColor', 'LabelColor',                                               90, Box_Color )
   RowClose ()

   RowOpen ()
   # --> 'USV "I/O" :'
   Input   ( 'Sec3LabelHeadline', 'AxisName',           90, Box_1b    )
   RowClose()

   RowOpen  ()
   # --> 'USV "I/O" :'
   Input    ( 'Sec3LabelSuffix',   'AxisUnit',          90, Box_1b    )
   RowClose ()

   RowOpen ()
   Select   ( 'Sec3LabelSize',  'LabelSize', '50 60 80 85 90 95 100 105 110 115 120',       90, Box_1b )
   RowClose ()

   RowOpen ()
   Input   ( 'Sec3LabelPos',    'Offset X :',                                                   90, Box_Input )
   RowClose ()

   RowOpen ()
   Input   ( 'Sec3LabelOffset', 'Offset Y :',                                                   90, Box_Input )
   RowClose ()

   # --------------------------------------------------------------------------------
   ContentTabEnd()
   ContentTab ( 390, 180 )
   # --------------------------------------------------------------------------------

   RowOpen   ()
   SelectGUI ( 'Sec3ScaleType',  'ScaleType', s['AxisScaleTypeGUI'], s['AxisScaleTypeRAW'],      95, 122 )
   RowClose  ()

   RowOpen   ()
   Select    ( 'UsvInputNominal',    'UsvInputNominal', '100 110 120 127 220 230 240',            95, Box_1b, True )
   RowClose  ()

   RowOpen   ()
   Select    ( 'UsvInputTolerance',    'UsvInputTolerance', '5 10 15',                            95, Box_1b, True )
   RowClose  ()


   RowOpen   ()
   RoBox     ( 'Sec3Min',        'Start :',                                                     95, Box_Input )
   RowClose  ()

   RowOpen   ()
   RoBox     ( 'Sec3ScaleMin',   'Min :',                                                    95, Box_Input )
   RowClose  ()

   RowOpen   ()
   RoBox     ( 'Sec3ScaleMax',   'Max :',                                                    95, Box_Input )
   RowClose  ()

   ContentTabEnd ()
   ContentRowEnd ()
   SectionClose  ()

   # --------------------------------------------------------------------------------
   iAccCnt += 1
   SectionOpen( 'Timeline', iIndex=iAccCnt )
   # --------------------------------------------------------------------------------

   RowOpen ()
   CheckBox( 'VerLabelOn',      'LabelOnOff',                                               100 )
   RowClose()

   RowOpen ()
   Color   ( 'VerLabelColor',   'LabelColor',                                               100, Box_Color )
   RowClose()

   RowOpen ()
   Select  ( 'VerLabelSize',    'LabelSize', '50 60 80 85 90 95 100 105 110 115 120',       100, Box_1b )
   RowClose()

   RowOpen ()
   Input   ( 'VerLabelPos',     'Offset X :',                                                   100, Box_Input )
   RowClose()

   RowOpen ()
   Input   ( 'VerLabelOffset',  'Offset Y :',                                                   100, Box_Input )
   RowClose()

   SectionClose  ()

   # --------------------------------------------------------------------------------
   ContentTabEnd()

   # --------------------------------------------------------------------------------
   # --- Display "Save" & "Undo" Button ...
   SaveUndo( asset.PageName, FuncName, iSize=80, iWidth=iWidth )
   # --------------------------------------------------------------------------------
   ContentClose()


# --------------------------------------- END ---------------------------------------
# -----------------------------------------------------------------------------------
#  sys.exit()
# -----------------------------------------------------------------------------------
# -----------------------------------------------------------------------------------
