# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

import asset
from   Html  import *

from   lib   import switch, case

# -----------------------------------------------------------------------------------
# --- Global options ...
# -----------------------------------------------------------------------------------
import __main__  as pMain

FuncName = 'line'

FuncDesc = { 'IconName'     : 'Lines.png',
             'SubName'      : asset.msg['modChartLineName'],
             'SubText'      : asset.msg['modChartLineText'],
             'iWidth'       : SubMenuWidth,
             'iOnChange'    : False ,
           }

# -----------------------------------------------------------------------------------
# --- Pre-Initialization
# -----------------------------------------------------------------------------------
def pre( site, more ) :
   pass

# -----------------------------------------------------------------------------------
# --- Post-Initialization
# -----------------------------------------------------------------------------------
def post( site, more ) :

   while switch( f'{site}+{more}' ) :
      # -----------------------------------------------------------------------------
      if case( 'line+save' ) :
         # --------------------------------------------------------------------------
         import main
         main.save()
         break

      # -----------------------------------------------------------------------------
      break

   # --------------------------------------------------------------------------------
   # --- Prepare Values ...
   for sKey in asset.cgiInput :
      asset.Out[ sKey] = asset.cgiInput[ sKey ]

# -----------------------------------------------------------------------------------
# --- Function : "line"
# -----------------------------------------------------------------------------------
def Func ( sSite, sMore ) :

   iWidth   = iMainOutWidth
   iHeight  = iMainHeight
   iAccCnt  = 0

   s           = asset.msg
   Out         = asset.Out

   if Out['ExpertModeOn'] == 'Yes': ExpertMode = True
   else                           : ExpertMode = False

   # --------------------------------------------------------------------------------
   ContentOpen()
   # --------------------------------------------------------------------------------
   ContentRow ()
   ContentTab ( iWidth, iHeight - iMainSaveHeight )
   # --------------------------------------------------------------------------------
   asset.Out['AcdActive'] = 1

   for key in asset.cgiInput :
      if 'AcdReturn' in key and asset.cgiInput[key] == 'Yes' :
         asset.Out['AcdActive'] = int( key.split( '_', 1 )[-1] )
         break
   # --------------------------------------------------------------------------------
   iAccCnt += 1
   SectionOpen( 'Temperature', iIndex=iAccCnt )

   Options ( 'CPU',      'CPU °C :' )
   Options ( 'Status',   'Thermal Status :' )
   Options ( 'HddMax',   'HDD max. °C :' )
   Options ( 'HddMin',   'HDD min. °C :' )
   Options ( 'HddAvr',   'HDD avr. °C :' )

   if Out['Ploti2cOn'] :         Options ( 'i2c',      'i2c NAS °C :' )

   for iID, sID in enumerate( asset.sTabEnv ):
      if Out['LogEnvOn' + sID ] == "Yes" : Options ( 'Ambiente' + sID, 'Ambiente °C %s :' % asset.dTabEnv[ iID ] )

   SectionClose()
   # --------------------------------------------------------------------------------
   iAccCnt += 1
   SectionOpen( 'LoadPercent', iIndex=iAccCnt )

   Options                               ( 'Load',         'System Load :'    )
   if Out['PlotPwmOn']         : Options ( 'Pwm',          'Fan Speed :'      )

   if Out['RamSelectDevice'] != "none" or ExpertMode :
      GUI = s['SelectRamGUI']
      sel = Out['RamDeviceListRAW']
      if '" "' in GUI : GUI = GUI.strip('"').split('" "')
      else:             GUI = GUI.split(' ')

      if '" "' in sel : sel = sel.strip('"').split('" "')
      else:             sel = sel.split(' ')

      for j in range( 0, len(sel) ) :
         if sel[j] == Out['RamSelectDevice'] : break

      Options ( 'Memory', 'RAM ' + GUI[j] + ' :' )

   SectionClose()
   # --------------------------------------------------------------------------------
   # --- !!! Do not enable (use) ExpertMode ... because we reached Valuelimit with "GET"-Methode !!!!
   # --------------------------------------------------------------------------------
   iAccCnt += 1
   SectionOpen( 'Network_IO', iIndex=iAccCnt )

   if Out['SpeedTestOn'] != "No" or ExpertMode :
      Options ( 'Ping', 'Ping (ms) :' )

   GUI = Out['EthDeviceListGUI']
   sel = Out['EthDeviceListRAW']
   if '" "' in GUI : GUI = GUI.strip('"').split('" "')
   else:             GUI = GUI.split(' ')

   if '" "' in sel : sel = sel.strip('"').split('" "')
   else:             sel = sel.split(' ')

   for i in range( 0, asset.TabEth_Max ) :
      if Out['Eth' + str(i) + 'Device'] == "speed" and Out['SpeedTestOn'] == "No" and not ExpertMode :
         continue

      if Out['Eth' + str(i) + 'Device'] != "none"  or ExpertMode :
         for j in range( 0, len(sel) ) :
            if sel[j] == Out['Eth' + str(i) + 'Device'] : break

         ID = s['modSynoNetworkIO'] + str( i )

         Options ( 'Eth' + str(i) + 'r', ID + ' RxD :' )
         Options ( 'Eth' + str(i) + 'w', ID + ' TxD :' )

   SectionClose()
   # --------------------------------------------------------------------------------
   iAccCnt += 1
   SectionOpen( 'Storage_IO', iIndex=iAccCnt )

   # --- "TabMd_Max" from "init.sh"
   GUI = Out['MdDeviceListGUI']
   sel = Out['MdDeviceListRAW']
   if '" "' in GUI : GUI = GUI.strip('"').split('" "')
   else:             GUI = GUI.split(' ')

   if '" "' in sel : sel = sel.strip('"').split('" "')
   else:             sel = sel.split(' ')

   for i in range( 0, asset.TabMd_Max ) :
      if Out['Md' + str(i) + 'Device'] != "none"  or ExpertMode :
         for j in range( 0, len(sel) ) :
            if sel[j] == Out['Md' + str(i) + 'Device'] : break

         ID = s['modSynoStorageIO'] + str( i )

         Options ( 'Md' + str(i) + 'r', ID + ' RD :' )
         Options ( 'Md' + str(i) + 'w', ID + ' WR :' )

   SectionClose()

   # --------------------------------------------------------------------------------
   if Out['PlotUsvLoadOn'] or Out['PlotUsvDischargeOn'] or Out['PlotUsvInputOn'] or ExpertMode :

      iAccCnt += 1
      SectionOpen( 'UpsInput_IO', iIndex=iAccCnt )

      if Out['PlotUsvLoadOn'     ] : Options ( 'UsvLoad',      'USV Load :'       )
      if Out['PlotUsvDischargeOn'] : Options ( 'UsvDischarge', 'USV Discharged :' )
      if Out['PlotUsvInputOn'    ] : Options ( 'UsvInput',     'USV Voltage :'    )
 
      SectionClose()
   # --------------------------------------------------------------------------------

   ContentTabEnd()
   ContentRowEnd()

   # --------------------------------------------------------------------------------
   # --- Display "Save" & "Undo" Button ...
   SaveUndo( asset.PageName, FuncName, iSize=80, iWidth=iWidth )
   # --------------------------------------------------------------------------------
   ContentClose()


# --------------------------------------- END ---------------------------------------
# -----------------------------------------------------------------------------------
#  sys.exit()
# -----------------------------------------------------------------------------------
# -----------------------------------------------------------------------------------
