# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

import asset
from   Html  import *

from   lib   import switch, case

# -----------------------------------------------------------------------------------
# --- Global options ...
# -----------------------------------------------------------------------------------
import __main__  as pMain

FuncName = 'syno'

FuncDesc = { 'IconName'     : 'Quellen.png',
             'SubName'      : asset.msg['modSourcesSynoName'],
             'SubText'      : asset.msg['modSourcesSynoText'],
             'iWidth'       : SubMenuWidth,
             'iOnChange'    : False,
           }

# -----------------------------------------------------------------------------------
# --- Pre-Initialization
# -----------------------------------------------------------------------------------
def pre( site, more, sub=False ) :

   while switch( f'{site}+{more}' ) :
      # -----------------------------------------------------------------------------
      if case( 'syno+save' ) :
         # --------------------------------------------------------------------------
         import main
         main.save()
         break

      # -----------------------------------------------------------------------------
      break

# -----------------------------------------------------------------------------------
# --- Post-Initialization
# -----------------------------------------------------------------------------------
def post( site, more, sub=False ) :
   pass

# -----------------------------------------------------------------------------------
# --- Function : "engine"
# -----------------------------------------------------------------------------------
def Func ( sSite, sMore ) :

   iWidth   = iMainOutWidth
   iHeight  = iMainHeight

   s           = asset.msg
   Out         = asset.Out

   # --------------------------------------------------------------------------------
   ContentOpen()
   # --------------------------------------------------------------------------------
   ContentRow ()
   ContentTab ( 465, 170 )
   # --------------------------------------------------------------------------------
   Section( 'modConfigIOMdl' )

   for iID in range ( 0, 5 ) :
      RowOpen   ()
      SelectGUI ( 'Md%sDevice' % str( iID ), s['modSynoStorageIO'] + '%s :' % str( iID + 1), Out['MdDeviceListGUI'], Out['MdDeviceListRAW'], Column_1, 260 )
      RowClose  ()

   ContentTabEnd()


   # --------------------------------------------------------------------------------
   ContentTab ( 315, 170 )
   # --------------------------------------------------------------------------------
   Section( 'modConfigIOEth' )

   for iID in range ( 0, 5 ) :
      RowOpen   ()
      SelectGUI ( 'Eth%sDevice' % str( iID ), s['modSynoNetworkIO'] + '%s :' % str( iID + 1), Out['EthDeviceListGUI'], Out['EthDeviceListRAW'], Column_1, 105 )
      RowClose  ()

   ContentTabEnd()
   ContentRowEnd()

   # --------------------------------------------------------------------------------
   ContentTab ( iWidth, 60 )
   # --------------------------------------------------------------------------------
   if Out[ 'PlotMemoryOn' ] :
      Section ( 'MemoryUsage' )

      RowOpen   ()
      SelectGUI ( 'RamSelectDevice', 'RamSelectDevice', s['SelectRamGUI'], Out['RamDeviceListRAW'], Column_1, 100 )
      RowClose  ()

   ContentTabEnd()

   # --------------------------------------------------------------------------------
   # --- Display "Save" & "Undo" Button ...
   SaveUndo( asset.PageName, FuncName, iSize=80, iWidth=iWidth )
   # --------------------------------------------------------------------------------
   ContentClose()


# --------------------------------------- END ---------------------------------------
# -----------------------------------------------------------------------------------
#  sys.exit()
# -----------------------------------------------------------------------------------
# -----------------------------------------------------------------------------------
