# -*- coding: utf-8 -*-

# -----------------------------------------------------------------------------------#
# AvrLogger - Monitoring and visualization tool.                                     #
# Copyright (C) 2018 by BigRonin.                                                    #
# Member of the German Synology Community Forum "https://www.synology-forum.de"      #
# -----------------------------------------------------------------------------------#
# This file is part of "AvrLogger.spk"                                               #
#                                                                                    #
# AvrLogger is free software: you can redistribute it and/or modify                  #
# it under the terms of the GNU General Public License as published by               #
# the Free Software Foundation, either version 3 of the License, or                  #
# (at your option) any later version.                                                #
# -----------------------------------------------------------------------------------#

import asset
from   Html  import *

from   lib   import switch, case

# -----------------------------------------------------------------------------------
# --- Global options ...
# -----------------------------------------------------------------------------------
FuncName = 'list'

FuncDesc = { 'IconName'     : 'Engine.png',
             'SubName'      : asset.msg['modConfigEngineName'],
             'SubText'      : asset.msg['modConfigEngineText'],
             'iWidth'       : SubMenuWidth,
             'iOnChange'    : False,
           }

# -----------------------------------------------------------------------------------
# --- Pre-Initialization
# -----------------------------------------------------------------------------------
def pre( site, more ) :

   while switch( f'{site}+{more}' ) :
      # -----------------------------------------------------------------------------
      if case( 'Func+save' ):
         # --------------------------------------------------------------------------
         if os.path.exists( asset.f_AvrDisabled ) : io.ioRm ( asset.f_AvrDisabled )
         else                                     : io.touch( asset.f_AvrDisabled )

         import main
         main.save( asset.PageName, '', '' )
         return f'{asset.PageName}-{FuncName}'

      # -----------------------------------------------------------------------------
      break

# -----------------------------------------------------------------------------------
# --- Post-Initialization
# -----------------------------------------------------------------------------------
def post( site, more ) :

   while switch( f'{site}+{more}' ) :
      # -----------------------------------------------------------------------------
      if case( 'axis+OnChange' ):
         UsvInputNominal   = int( asset.cgiInput[ 'UsvInputNominal'   ] )
         UsvInputTolerance = int( asset.cgiInput[ 'UsvInputTolerance' ] )

         UsvInputMin = int( ( UsvInputNominal / 100 ) * ( 100 - UsvInputTolerance ) )
         UsvInputMax = int( ( UsvInputNominal / 100 ) * ( 100 + UsvInputTolerance ) )

         asset.cgiInput[ 'Sec3Min'      ] = f'{UsvInputMin}' # Start-Wert
         asset.cgiInput[ 'Sec3ScaleMin' ] = f'{UsvInputMin}' # Skalierung Min.
         asset.cgiInput[ 'Sec3ScaleMax' ] = f'{UsvInputMax}' # Skalierung Max.

         break

      # -----------------------------------------------------------------------------
      break

   # --------------------------------------------------------------------------------
   # --- Prepare Values ...
   for sKey in asset.cgiInput :
      asset.Out[ sKey] = asset.cgiInput[ sKey ]

# -----------------------------------------------------------------------------------
# --- Function : "engine"
# -----------------------------------------------------------------------------------
def Func ( sSite, sMore ) :

   iWidth   = iMainOutWidth
   iHeight  = iMainHeight

   s           = asset.msg
   Out         = asset.Out

   # --------------------------------------------------------------------------------
   ContentOpen()
   # --------------------------------------------------------------------------------
   ContentRow ()
   ContentTab ( iWidth, 100 )
   # --------------------------------------------------------------------------------

   Section ( 'DaemonConfirm' )

   if os.path.exists( asset.f_AvrDisabled ) : Text = s[ 'ButtonDaemonStart' ]
   else                                     : Text = s[ 'ButtonDaemonStop'  ]

   RowOpen  ()
   Label    ( 'DaemonConfirm', Column_1 )
   Button   ( 'ButtonDaemon' , Text, PageName + '-engine+init',  iSize=80 )
   RowClose ()

   # --------------------------------------------------------------------------------
   ContentTabEnd()
   ContentRowEnd()
   # --------------------------------------------------------------------------------
   ContentClose()

# --------------------------------------- END ---------------------------------------
# -----------------------------------------------------------------------------------
#  sys.exit()
# -----------------------------------------------------------------------------------
# -----------------------------------------------------------------------------------
