// -------------------------------------------------------------------------------- //
// AvrLogger - Monitoring and visualization tool.                                   //
// Copyright (C) 2018 by BigRonin.                                                  //
// Member of the German Synology Community Forum "https://www.synology-forum.de"    //
// coding: utf-8                                                                    //
// -------------------------------------------------------------------------------- //
// This file is part of "AvrLogger.spk"                                             //
//                                                                                  //
// AvrLogger is free software: you can redistribute it and/or modify                //
// it under the terms of the GNU General Public License as published by             //
// the Free Software Foundation, either version 3 of the License, or                //
// (at your option) any later version.                                              //
// -------------------------------------------------------------------------------- //
// Coding: utf-8                                                                    //
// -------------------------------------------------------------------------------- //

// -------------------------------------------------------------------------------- //
// --- Global Options :
// -------------------------------------------------------------------------------- //
var pop              = null;
var rtfPop           = null;
var ChartImage       = false;
var rtfAvrStatus     = null;
var ajaxEvnCalls = {
                     'svgLineChart' : function( sArray ) { ajaxExtSvgLineChart( sArray ); },
               //    'SvgTime'      : function( sArray ) { ajaxExtSvgTime(      sArray ); },
                   };

// -------------------------------------------------------------------------------- //
// --- Set and reload LineChart if necessary ...
// -------------------------------------------------------------------------------- //
function ajaxExtSvgLineChart( sTripple ) {

   var obj = sTripple[ 'result' ];

   if ( !obj ) return false;

   // --- Update LineChart ...
   if ( obj[ 'LineChart' ] !== ChartImage )
   {
      ChartImage = obj[ 'LineChart' ];
      $("#LineChart").attr( "src", ChartImage );
   }

   // --- Get PID-Status of Deamon ...
   if ( 'rtfAvrStatus' in obj )
   {
      if ( rtfAvrStatus != obj[ 'rtfAvrStatus' ][ 'rtfStatusIcon'] )
      {
         var Icon = 'images/' + obj['rtfAvrStatus']['rtfStatusIcon'];
         $("#callConfig").attr( "src", Icon );

      // var Text = obj['rtfAvrStatus']['rtfStatusText'] + ' : Setup';
         var Text = obj['rtfAvrStatus']['rtfStatusText'];
         $("#callConfig").attr( "title", Text );
         
         rtfAvrStatus = obj[ 'rtfAvrStatus' ][ 'rtfStatusIcon'];
      }
   }

   return true;
}

// -------------------------------------------------------------------------------- //
// --- Scroll DIV to Specific Location
// -------------------------------------------------------------------------------- //
function rtfScrollDivTo( sScrollDivID, sSelectedClass ) {

   $( '#' + sScrollDivID ).scrollTop( $( '\.' + sSelectedClass ).position().top );
}


var rtfBusyLoadFlag = false;

// -------------------------------------------------------------------------------- //
// --- Hide a PoUp Message :
// -------------------------------------------------------------------------------- //
function rtfBusyLoadReady( jQuery ) {

   var cls = document.querySelectorAll( '#rtfBusyLoad' );
   for ( var i = 0; i < cls.length; i++ )
   {
      cls[i].style.display = 'none';
   }

   rtfBusyLoadFlag = true;
}

function rtfBusyLoadWait( jQuery ) {

    setTimeout( function()
    {
      if ( rtfBusyLoadFlag ) return;
      document.querySelector( '#rtfBusyLoad' ).style.display = 'block';
    }, 500 );
}
// -------------------------------------------------------------------------------- //
// --- Server request via "ajax" :
// --- sEvent = Event-Function ( requestet Server Function )
// -------------------------------------------------------------------------------- //
var requestAjaxLock = false   // --- Lock flag to prevent stacking

function requestAjax( sEvent, sPage, sMore, sSite ) {

   if ( requestAjaxLock )
   {
      return;
   }

   var sRequest = {
                     "ajaxEvent" :  sEvent,
                     "ajaxPage"  :  sPage,
                     "ajaxMore"  :  sMore ,
                     "ajaxSite"  :  sSite,
                  };

   requestAjaxLock = true;

   $.ajax(
      {
         type        :  "POST",
         cache       :  false,
         url         :  "Ajax.cgi",
         dataType    :  "json",
         contentType :  "application/json; charset=utf-8",

         data        :  JSON.stringify( sRequest ),

         success     :  function( sResponse ) { responseAjax( sResponse, sEvent ); },
         failure     :  function( errMsg    ) { failureAjax( errMsg     ); },
      } );
}

function responseAjax( sResponse, sEvent ) {

   ajaxEvnCalls[ sEvent ]( sResponse );
   requestAjaxLock = false;

}

function failureAjax( sError ) {

   console.log( 'Ajax Responce Error :' );
   console.log( sError );
   requestAjaxLock = false;

}

// -------------------------------------------------------------------------------- //
// --- Simple jQuery Accordion :
// --- Based on : http://www.normansblog.de/simple-jquery-accordion/
// --- $(document).ready( rtfAccordion )
// -------------------------------------------------------------------------------- //
var rtfToggleSpeed = 200

function rtfAccordion( jQuery ) {

   $( '.trigger' ).not( '.trigger_active' ).next( '.toggle_container' ).hide();

   $( '.trigger' ).click( function() {
      var trig = $( this );
      if ( trig.hasClass( 'trigger_active' ) )
      {  // ----------------------------------------------------------------------- //
         // --- Close :
      // trig.next( '.toggle_container' ).slideToggle( 'fast' );
         trig.next( '.toggle_container' ).slideToggle( rtfToggleSpeed );
         $( '.trigger_active' ).next().children( 'input:hidden').val( 'No' );
         var img = $( '.trigger_active' ).find( 'img' );
         img.attr('src','images/AccClose.png');
         trig.removeClass( 'trigger_active' );
      }
      else
      {  // ----------------------------------------------------------------------- //
         // --- Close :
         $( '.trigger_active' ).next( '.toggle_container' ).slideToggle( rtfToggleSpeed );
         $( '.trigger_active' ).next().children( 'input:hidden').val( 'No' );
         var img = $( '.trigger_active' ).find( 'img' );
         img.attr('src','images/AccClose.png');
         $( '.trigger_active' ).removeClass( 'trigger_active' );

         // ----------------------------------------------------------------------- //
         // --- Open :
         trig.next( '.toggle_container' ).slideToggle( rtfToggleSpeed );
         trig.next().children( 'input:hidden').val( 'Yes' );
         var img = trig.find( 'img' );
         img.attr('src','images/AccOpen.png');
         trig.addClass( 'trigger_active' );
      };
      return false;
   } );
}

// -------------------------------------------------------------------------------- //
// --- Close "popup" ...
// -------------------------------------------------------------------------------- //
function rtfcloseWindow() {
   if ( rtfPop && !rtfPop.closed ) rtfPop.close();
}

// -------------------------------------------------------------------------------- //
// --- Open new (popup) Window by DOMelement ...
// -------------------------------------------------------------------------------- //
function rtfNewWindow( obj, w, h, win, close, url ) {

   // ----------------------------------------------------------------------------- //
   // --- If the size was not specified : set to default values ...
   w = (w) ? w : 750;
   h = (h) ? h : 450;

   const iSticky = ( close ) ? true : false;

   // ----------------------------------------------------------------------------- //
   // --- Place in center of the current screen ...
   var args = null;
   args  =  'width='  + w;
   args += ',height=' + h;
   args += ',left='   + ( win.top.outerWidth  / 2 + win.top.screenX - ( w / 2 ) );
   args += ',top='    + ( win.top.outerHeight / 2 + win.top.screenY - ( h / 2 ) );
   args += ',resizable';

   rtfcloseWindow();
   rtfPop = window.open( url, '', args );

// if ( iSticky == true ) {
//    window.onfocus  = rtfcloseWindow;
// }

   window.onunload = rtfcloseWindow;
   return ( rtfPop ) ? false : true;
}

// -------------------------------------------------------------------------------- //
// --- Based on : https://www.stichpunkt.de/beitrag/popup.html                      //
// -------------------------------------------------------------------------------- //
// --- Close "popup" ...
// -------------------------------------------------------------------------------- //
function closeWindow() {
   if ( pop && !pop.closed ) pop.close();
}

// -------------------------------------------------------------------------------- //
// --- Resize current Window ...
// -------------------------------------------------------------------------------- //
function resizeWindow( w, h ) {

   window.resizeTo( w, h );

}
// -------------------------------------------------------------------------------- //
// --- Open new (popup) Window by DOMelement ...
// -------------------------------------------------------------------------------- //
function openWindow( obj, w, h, win, close ) {

   var url  = ( obj.getAttribute ) ? obj.getAttribute( 'href' ) : obj.href;
   if ( !url ) return true;

   const iSticky = ( close ) ? true : false;
   var args = null;

   // ----------------------------------------------------------------------------- //
   // --- If the size was not specified : set to default values ...
   w = (w) ? w : 750;
   h = (h) ? h : 450;

   // ----------------------------------------------------------------------------- //
   // --- Place in center of the current screen ...
   args  =  'width='  + w;
   args += ',height=' + h;
   args += ',left='   + ( win.top.outerWidth  / 2 + win.top.screenX - ( w / 2 ) );
   args += ',top='    + ( win.top.outerHeight / 2 + win.top.screenY - ( h / 2 ) );
   args += ',resizable';

   closeWindow();
   pop = window.open( url, '', args );

   if ( iSticky == true ) {
   // window.onunload = closeWindow;
      window.onfocus  = closeWindow;
   }

   window.onunload = closeWindow;
   return ( pop ) ? false : true;
}

// -------------------------------------- END ------------------------------------- //
// -------------------------------------------------------------------------------- //

